FIX: Remove unwanted Jenkins dependency
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2019 Cisco and/or its affiliates.
2 # Copyright (c) 2019 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx" | "1n_tx2")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # backtics to avoid https://midnight-commander.org/ticket/2142
57             env_vars=`${ssh} "$(declare -f); ${run}"` || {
58                 die "Topology reservation via shim-dcr failed!"
59             }
60             set -a
61             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
62                 die "Source failed!"
63             }
64             set +a
65             ;;
66         "1n_vbox")
67             # We execute reservation on localhost. Sourced script automatially
68             # sets environment variables for further processing.
69             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
70             ;;
71         *)
72             die "Unknown specification: ${case_text}!"
73     esac
74
75     trap 'deactivate_docker_topology' EXIT || {
76          die "Trap attempt failed, please cleanup manually. Aborting!"
77     }
78
79     # Replace all variables in template with those in environment.
80     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
81         die "Topology file create failed!"
82     }
83
84     WORKING_TOPOLOGY="/tmp/topology.yaml"
85     mv topo.yml "${WORKING_TOPOLOGY}" || {
86         die "Topology move failed!"
87     }
88     cat ${WORKING_TOPOLOGY} | grep -v password || {
89         die "Topology read failed!"
90     }
91 }
92
93
94 function activate_virtualenv () {
95
96     # Update virtualenv pip package, delete and create virtualenv directory,
97     # activate the virtualenv, install requirements, set PYTHONPATH.
98
99     # Arguments:
100     # - ${1} - Path to existing directory for creating virtualenv in.
101     #          If missing or empty, ${CSIT_DIR} is used.
102     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
103     # Variables read:
104     # - CSIT_DIR - Path to existing root of local CSIT git repository.
105     # Variables exported:
106     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
107     # Functions called:
108     # - die - Print to stderr and exit.
109
110     set -exuo pipefail
111
112     root_path="${1-$CSIT_DIR}"
113     env_dir="${root_path}/env"
114     req_path=${2-$CSIT_DIR/requirements.txt}
115     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
116     pip install --upgrade virtualenv || {
117         die "Virtualenv package install failed."
118     }
119     virtualenv "${env_dir}" || {
120         die "Virtualenv creation failed."
121     }
122     set +u
123     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
124     set -u
125     pip install --upgrade -r "${req_path}" || {
126         die "Requirements installation failed."
127     }
128     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
129     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
130 }
131
132
133 function archive_tests () {
134
135     # Create .tar.xz of generated/tests for archiving.
136     # To be run after generate_tests, kept separate to offer more flexibility.
137
138     # Directory read:
139     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
140     # File rewriten:
141     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
142
143     set -exuo pipefail
144
145     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
146         die "Error creating archive of generated tests."
147     }
148 }
149
150
151 function check_download_dir () {
152
153     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
154     #
155     # Variables read:
156     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
157     # Directories read:
158     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
159     # Functions called:
160     # - die - Print to stderr and exit.
161
162     set -exuo pipefail
163
164     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
165         die "No artifacts downloaded!"
166     fi
167 }
168
169
170 function check_prerequisites () {
171
172     # Fail if prerequisites are not met.
173     #
174     # Functions called:
175     # - installed - Check if application is installed/present in system.
176     # - die - Print to stderr and exit.
177
178     set -exuo pipefail
179
180     if ! installed sshpass; then
181         die "Please install sshpass before continue!"
182     fi
183 }
184
185 function cleanup_topo () {
186
187     # Variables read:
188     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
189     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
190
191     set -exuo pipefail
192
193     python "${PYTHON_SCRIPTS_DIR}/topo_cleanup.py" -t "${WORKING_TOPOLOGY}"
194     # Not using "|| die" as some callers might want to ignore errors,
195     # e.g. in teardowns, such as unreserve.
196 }
197
198
199 function common_dirs () {
200
201     # Set global variables, create some directories (without touching content).
202
203     # Variables set:
204     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
205     # - CSIT_DIR - Path to existing root of local CSIT git repository.
206     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
207     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
208     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
209     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
210     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
211     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
212     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
213     # Directories created if not present:
214     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
215     # Functions called:
216     # - die - Print to stderr and exit.
217
218     set -exuo pipefail
219
220     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
221         die "Some error during locating of this source file."
222     }
223     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
224         die "Some error during dirname call."
225     }
226     # Current working directory could be in a different repo, e.g. VPP.
227     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
228     relative_csit_dir=$(git rev-parse --show-toplevel) || {
229         die "Git rev-parse failed."
230     }
231     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
232     popd || die "Popd failed."
233     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
234         die "Readlink failed."
235     }
236     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
237         die "Readlink failed."
238     }
239     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
240         die "Readlink failed."
241     }
242     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
243         die "Readlink failed."
244     }
245
246     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
247         die "Readlink failed."
248     }
249     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
250     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
251         die "Readlink failed."
252     }
253     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
254     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
255         die "Readlink failed."
256     }
257     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
258 }
259
260
261 function compose_pybot_arguments () {
262
263     # Variables read:
264     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
265     # - DUT - CSIT test/ subdirectory, set while processing tags.
266     # - TAGS - Array variable holding selected tag boolean expressions.
267     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
268     # - TEST_CODE - The test selection string from environment or argument.
269     # Variables set:
270     # - PYBOT_ARGS - String holding part of all arguments for pybot.
271     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
272
273     set -exuo pipefail
274
275     # No explicit check needed with "set -u".
276     PYBOT_ARGS=("--loglevel" "TRACE")
277     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
278
279     case "${TEST_CODE}" in
280         *"device"*)
281             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
282             ;;
283         *"func"*)
284             PYBOT_ARGS+=("--suite" "tests.${DUT}.func")
285             ;;
286         *"perf"*)
287             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
288             ;;
289         *)
290             die "Unknown specification: ${TEST_CODE}"
291     esac
292
293     EXPANDED_TAGS=()
294     for tag in "${TAGS[@]}"; do
295         if [[ ${tag} == "!"* ]]; then
296             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
297         else
298             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
299         fi
300     done
301 }
302
303
304 function copy_archives () {
305
306     # Create additional archive if workspace variable is set.
307     # This way if script is running in jenkins all will be
308     # automatically archived to logs.fd.io.
309     #
310     # Variables read:
311     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
312     #   Can be unset, then it speeds up manual testing.
313     # - ARCHIVE_DIR - Path to directory with content to be copied.
314     # Directories updated:
315     # - ${WORKSPACE}/archives/ - Created if does not exist.
316     #   Content of ${ARCHIVE_DIR}/ is copied here.
317     # Functions called:
318     # - die - Print to stderr and exit.
319
320     set -exuo pipefail
321
322     if [[ -n "${WORKSPACE-}" ]]; then
323         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
324         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
325     fi
326 }
327
328
329 function deactivate_docker_topology () {
330
331     # Deactivate virtual vpp-device topology by removing containers.
332     #
333     # Variables read:
334     # - NODENESS - Node multiplicity of desired testbed.
335     # - FLAVOR - Node flavor string, usually describing the processor.
336
337     set -exuo pipefail
338
339     case_text="${NODENESS}_${FLAVOR}"
340     case "${case_text}" in
341         "1n_skx" | "1n_tx2")
342             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
343             ssh="ssh root@${hostname} -p 6022"
344             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
345             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
346                 die "Topology cleanup via shim-dcr failed!"
347             }
348             ;;
349         "1n_vbox")
350             enter_mutex || die
351             clean_environment || {
352                 die "Topology cleanup locally failed!"
353             }
354             exit_mutex || die
355             ;;
356         *)
357             die "Unknown specification: ${case_text}!"
358     esac
359 }
360
361
362 function die () {
363
364     # Print the message to standard error end exit with error code specified
365     # by the second argument.
366     #
367     # Hardcoded values:
368     # - The default error message.
369     # Arguments:
370     # - ${1} - The whole error message, be sure to quote. Optional
371     # - ${2} - the code to exit with, default: 1.
372
373     set -x
374     set +eu
375     warn "${1:-Unspecified run-time error occurred!}"
376     exit "${2:-1}"
377 }
378
379
380 function die_on_pybot_error () {
381
382     # Source this fragment if you want to abort on any failed test case.
383     #
384     # Variables read:
385     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
386     # Functions called:
387     # - die - Print to stderr and exit.
388
389     set -exuo pipefail
390
391     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
392         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
393     fi
394 }
395
396
397 function generate_tests () {
398
399     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
400     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
401     # The generation is done by executing any *.py executable
402     # within any subdirectory after copying.
403
404     # This is a separate function, because this code is called
405     # both by autogen checker and entries calling run_pybot.
406
407     # Directories read:
408     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
409     # Directories replaced:
410     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
411
412     set -exuo pipefail
413
414     rm -rf "${GENERATED_DIR}/tests" || die
415     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
416     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
417     cmd_line+=("-executable" "-name" "*.py")
418     file_list=$("${cmd_line[@]}") || die
419
420     for gen in ${file_list}; do
421         directory="$(dirname "${gen}")" || die
422         filename="$(basename "${gen}")" || die
423         pushd "${directory}" || die
424         ./"${filename}" || die
425         popd || die
426     done
427 }
428
429
430 function get_test_code () {
431
432     # Arguments:
433     # - ${1} - Optional, argument of entry script (or empty as unset).
434     #   Test code value to override job name from environment.
435     # Variables read:
436     # - JOB_NAME - String affecting test selection, default if not argument.
437     # Variables set:
438     # - TEST_CODE - The test selection string from environment or argument.
439     # - NODENESS - Node multiplicity of desired testbed.
440     # - FLAVOR - Node flavor string, usually describing the processor.
441
442     set -exuo pipefail
443
444     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
445     if [[ -z "${TEST_CODE}" ]]; then
446         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
447     fi
448
449     case "${TEST_CODE}" in
450         *"1n-vbox"*)
451             NODENESS="1n"
452             FLAVOR="vbox"
453             ;;
454         *"1n-skx"*)
455             NODENESS="1n"
456             FLAVOR="skx"
457             ;;
458        *"1n-tx2"*)
459             NODENESS="1n"
460             FLAVOR="tx2"
461             ;;
462         *"2n-skx"*)
463             NODENESS="2n"
464             FLAVOR="skx"
465             ;;
466         *"3n-skx"*)
467             NODENESS="3n"
468             FLAVOR="skx"
469             ;;
470         *"2n-dnv"*)
471             NODENESS="2n"
472             FLAVOR="dnv"
473             ;;
474         *"3n-dnv"*)
475             NODENESS="3n"
476             FLAVOR="dnv"
477             ;;
478         *"3n-tsh"*)
479             NODENESS="3n"
480             FLAVOR="tsh"
481             ;;
482         *)
483             # Fallback to 3-node Haswell by default (backward compatibility)
484             NODENESS="3n"
485             FLAVOR="hsw"
486             ;;
487     esac
488 }
489
490
491 function get_test_tag_string () {
492
493     # Variables read:
494     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
495     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
496     # - TEST_CODE - The test selection string from environment or argument.
497     # Variables set:
498     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
499     #   May be empty, not set on event types not adding comment.
500
501     # TODO: ci-management scripts no longer need to perform this.
502
503     set -exuo pipefail
504
505     trigger=""
506     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
507         case "${TEST_CODE}" in
508             *"device"*)
509                 # On parsing error, ${trigger} stays empty.
510                 trigger="$(echo "${GERRIT_EVENT_COMMENT_TEXT}" \
511                     | grep -oE '(devicetest$|devicetest[[:space:]].+$)')" \
512                     || true
513                 # Set test tags as string.
514                 TEST_TAG_STRING="${trigger#$"devicetest"}"
515                 ;;
516             *"perf"*)
517                 # On parsing error, ${trigger} stays empty.
518                 comment="${GERRIT_EVENT_COMMENT_TEXT}"
519                 # As "perftest" can be followed by something, we substitute it.
520                 comment="${comment/perftest-2n/perftest}"
521                 comment="${comment/perftest-3n/perftest}"
522                 comment="${comment/perftest-hsw/perftest}"
523                 comment="${comment/perftest-skx/perftest}"
524                 comment="${comment/perftest-dnv/perftest}"
525                 comment="${comment/perftest-tsh/perftest}"
526                 tag_string="$(echo "${comment}" \
527                     | grep -oE '(perftest$|perftest[[:space:]].+$)' || true)"
528                 # Set test tags as string.
529                 TEST_TAG_STRING="${tag_string#$"perftest"}"
530                 ;;
531             *)
532                 die "Unknown specification: ${TEST_CODE}"
533         esac
534     fi
535 }
536
537
538 function installed () {
539
540     # Check if the given utility is installed. Fail if not installed.
541     #
542     # Duplicate of common.sh function, as this file is also used standalone.
543     #
544     # Arguments:
545     # - ${1} - Utility to check.
546     # Returns:
547     # - 0 - If command is installed.
548     # - 1 - If command is not installed.
549
550     set -exuo pipefail
551
552     command -v "${1}"
553 }
554
555
556 function remove_topo () {
557
558     # Remove the argument from list of available topologies.
559     #
560     # Just a de-duplicated block of code
561     #
562     # Argument:
563     # - ${1} - The topology item to remove. Required.
564     # Variable read and re-written:
565     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
566
567     set -exuo pipefail
568
569     warn "Testbed ${topo} seems unsuitable, removing from the list."
570
571     # Build new topology array.
572     #   TOPOLOGIES=("${TOPOLOGIES[@]/$topo}")
573     # does not really work, see:
574     # https://stackoverflow.com/questions/16860877/remove-an-element-from-a-bash-array
575
576     new_topologies=()
577     for item in "${TOPOLOGIES[@]}"; do
578         if [[ "${item}" != "${1}" ]]; then
579             new_topologies+=("${item}")
580         fi
581     done
582     TOPOLOGIES=("${new_topologies[@]}")
583 }
584
585
586 function reserve_and_cleanup_testbed () {
587
588     # Reserve physical testbed, perform cleanup, register trap to unreserve.
589     # When cleanup fails, remove from topologies and keep retrying
590     # until all topologies are removed.
591     #
592     # Variables read:
593     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
594     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
595     # - BUILD_TAG - Any string suitable as filename, identifying
596     #   test run executing this function. May be unset.
597     # Variables set:
598     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
599     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
600     # Functions called:
601     # - die - Print to stderr and exit.
602     # Traps registered:
603     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
604
605     set -exuo pipefail
606
607     while true; do
608         for topo in "${TOPOLOGIES[@]}"; do
609             set +e
610             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
611             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
612             python "${scrpt}" "${opts[@]}"
613             result="$?"
614             set -e
615             if [[ "${result}" == "0" ]]; then
616                 # Trap unreservation before cleanup check,
617                 # so multiple jobs showing failed cleanup improve chances
618                 # of humans to notice and fix.
619                 WORKING_TOPOLOGY="${topo}"
620                 echo "Reserved: ${WORKING_TOPOLOGY}"
621                 trap "untrap_and_unreserve_testbed" EXIT || {
622                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
623                     untrap_and_unreserve_testbed "${message}" || {
624                         die "Teardown should have died, not failed."
625                     }
626                     die "Trap attempt failed, unreserve succeeded. Aborting."
627                 }
628                 # Cleanup check.
629                 set +e
630                 cleanup_topo
631                 result="$?"
632                 set -e
633                 if [[ "${result}" == "0" ]]; then
634                     break
635                 fi
636                 warn "Testbed cleanup failed: ${topo}"
637                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
638                 # WORKING_TOPOLOGY is now empty again.
639                 remove_topo "${topo}"
640             elif [[ "${result}" != "2" ]]; then
641                 # 1 or unexpected return code, testbed is probably unusable.
642                 remove_topo "${topo}"
643             fi
644             # Else testbed is accessible but currently reserved, moving on.
645         done
646
647         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
648             # Exit the infinite while loop if we made a reservation.
649             warn "Reservation and cleanup successful."
650             break
651         fi
652
653         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
654             die "Run out of operational testbeds!"
655         fi
656
657         # Wait ~3minutes before next try.
658         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
659             die "Sleep time calculation failed."
660         }
661         echo "Sleeping ${sleep_time}"
662         sleep "${sleep_time}" || die "Sleep failed."
663     done
664 }
665
666
667 function run_pybot () {
668
669     # Run pybot with options based on input variables. Create output_info.xml
670     #
671     # Variables read:
672     # - CSIT_DIR - Path to existing root of local CSIT git repository.
673     # - ARCHIVE_DIR - Path to store robot result files in.
674     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
675     # - GENERATED_DIR - Tests are assumed to be generated under there.
676     # Variables set:
677     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
678     # Functions called:
679     # - die - Print to stderr and exit.
680
681     set -exuo pipefail
682
683     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
684     all_options+=("--noncritical" "EXPECTED_FAILING")
685     all_options+=("${EXPANDED_TAGS[@]}")
686
687     pushd "${CSIT_DIR}" || die "Change directory operation failed."
688     set +e
689     pybot "${all_options[@]}" "${GENERATED_DIR}/tests/"
690     PYBOT_EXIT_STATUS="$?"
691     set -e
692
693     # Generate INFO level output_info.xml for post-processing.
694     all_options=("--loglevel" "INFO")
695     all_options+=("--log" "none")
696     all_options+=("--report" "none")
697     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
698     all_options+=("${ARCHIVE_DIR}/output.xml")
699     rebot "${all_options[@]}" || true
700     popd || die "Change directory operation failed."
701 }
702
703
704 function select_arch_os () {
705
706     # Set variables affected by local CPU architecture and operating system.
707     #
708     # Variables set:
709     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
710     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
711     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
712
713     set -exuo pipefail
714
715     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
716         die "Get OS release failed."
717     }
718
719     case "${os_id}" in
720         "ubuntu"*)
721             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
722             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
723             PKG_SUFFIX="deb"
724             ;;
725         "centos"*)
726             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
727             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
728             PKG_SUFFIX="rpm"
729             ;;
730         *)
731             die "Unable to identify distro or os from ${os_id}"
732             ;;
733     esac
734
735     arch=$(uname -m) || {
736         die "Get CPU architecture failed."
737     }
738
739     case "${arch}" in
740         "aarch64")
741             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
742             ;;
743         *)
744             ;;
745     esac
746 }
747
748
749 function select_tags () {
750
751     # Variables read:
752     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
753     # - TEST_CODE - String affecting test selection, usually jenkins job name.
754     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
755     #   Can be unset.
756     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
757     # - BASH_FUNCTION_DIR - Directory with input files to process.
758     # Variables set:
759     # - TAGS - Array of processed tag boolean expressions.
760
761     set -exuo pipefail
762
763     # NIC SELECTION
764     start_pattern='^  TG:'
765     end_pattern='^ \? \?[A-Za-z0-9]\+:'
766     # Remove the TG section from topology file
767     sed_command="/${start_pattern}/,/${end_pattern}/d"
768     # All topologies DUT NICs
769     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
770                 | grep -hoP "model: \K.*" | sort -u)
771     # Selected topology DUT NICs
772     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
773                | grep -hoP "model: \K.*" | sort -u)
774     # All topologies DUT NICs - Selected topology DUT NICs
775     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
776         die "Computation of excluded NICs failed."
777     }
778
779     # Select default NIC tag.
780     case "${TEST_CODE}" in
781         *"3n-dnv"* | *"2n-dnv"*)
782             default_nic="nic_intel-x553"
783             ;;
784         *"3n-tsh"*)
785             default_nic="nic_intel-x520-da2"
786             ;;
787         *)
788             default_nic="nic_intel-x710"
789             ;;
790     esac
791
792     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
793     # Tag file directory shorthand.
794     tfd="${BASH_FUNCTION_DIR}"
795     case "${TEST_CODE}" in
796         # Select specific performance tests based on jenkins job type variable.
797         *"ndrpdr-weekly"* )
798             readarray -t test_tag_array < "${tfd}/mlr-weekly.txt" || die
799             ;;
800         *"mrr-daily"* )
801             readarray -t test_tag_array <<< $(${sed_nic_sub_cmd} \
802                 ${tfd}/mrr-daily-${FLAVOR}.txt) || die
803             ;;
804         *"mrr-weekly"* )
805             readarray -t test_tag_array < "${tfd}/mrr-weekly.txt" || die
806             ;;
807         * )
808             if [[ -z "${TEST_TAG_STRING-}" ]]; then
809                 # If nothing is specified, we will run pre-selected tests by
810                 # following tags.
811                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
812                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
813                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
814                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
815                                 "!dot1q" "!drv_avf")
816             else
817                 # If trigger contains tags, split them into array.
818                 test_tag_array=(${TEST_TAG_STRING//:/ })
819             fi
820             ;;
821     esac
822
823     # Blacklisting certain tags per topology.
824     #
825     # Reasons for blacklisting:
826     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
827     # TODO: Add missing reasons here (if general) or where used (if specific).
828     case "${TEST_CODE}" in
829         *"2n-skx"*)
830             test_tag_array+=("!ipsechw")
831             ;;
832         *"3n-skx"*)
833             test_tag_array+=("!ipsechw")
834             # Not enough nic_intel-xxv710 to support double link tests.
835             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
836             ;;
837         *"2n-dnv"*)
838             test_tag_array+=("!ipsechw")
839             test_tag_array+=("!memif")
840             test_tag_array+=("!srv6_proxy")
841             test_tag_array+=("!vhost")
842             test_tag_array+=("!vts")
843             test_tag_array+=("!drv_avf")
844             ;;
845         *"3n-dnv"*)
846             test_tag_array+=("!memif")
847             test_tag_array+=("!srv6_proxy")
848             test_tag_array+=("!vhost")
849             test_tag_array+=("!vts")
850             test_tag_array+=("!drv_avf")
851             ;;
852         *"3n-tsh"*)
853             # 3n-tsh only has x520 NICs which don't work with AVF
854             test_tag_array+=("!drv_avf")
855             test_tag_array+=("!ipsechw")
856             ;;
857         *"3n-hsw"*)
858             # TODO: Introduce NOIOMMU version of AVF tests.
859             # TODO: Make (both) AVF tests work on Haswell,
860             # or document why (some of) it is not possible.
861             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
862             test_tag_array+=("!drv_avf")
863             # All cards have access to QAT. But only one card (xl710)
864             # resides in same NUMA as QAT. Other cards must go over QPI
865             # which we do not want to even run.
866             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
867             ;;
868         *)
869             # Default to 3n-hsw due to compatibility.
870             test_tag_array+=("!drv_avf")
871             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
872             ;;
873     esac
874
875     # We will add excluded NICs.
876     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
877
878     TAGS=()
879
880     # We will prefix with perftest to prevent running other tests
881     # (e.g. Functional).
882     prefix="perftestAND"
883     set +x
884     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
885         # Automatic prefixing for VPP jobs to limit the NIC used and
886         # traffic evaluation to MRR.
887         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
888             prefix="${prefix}mrrAND"
889         else
890             prefix="${prefix}mrrAND${default_nic}AND"
891         fi
892     fi
893     for tag in "${test_tag_array[@]}"; do
894         if [[ "${tag}" == "!"* ]]; then
895             # Exclude tags are not prefixed.
896             TAGS+=("${tag}")
897         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
898             # Empty and comment lines are skipped.
899             # Other lines are normal tags, they are to be prefixed.
900             TAGS+=("${prefix}${tag}")
901         fi
902     done
903     set -x
904 }
905
906
907 function select_topology () {
908
909     # Variables read:
910     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
911     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
912     # - CSIT_DIR - Path to existing root of local CSIT git repository.
913     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
914     # Variables set:
915     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
916     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
917     # Functions called:
918     # - die - Print to stderr and exit.
919
920     set -exuo pipefail
921
922     case_text="${NODENESS}_${FLAVOR}"
923     case "${case_text}" in
924         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
925         # TODO: Double link availability depends on NIC used.
926         "1n_vbox")
927             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
928             TOPOLOGIES_TAGS="2_node_single_link_topo"
929             ;;
930         "1n_skx" | "1n_tx2")
931             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
932             TOPOLOGIES_TAGS="2_node_single_link_topo"
933             ;;
934         "2n_skx")
935             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
936             TOPOLOGIES_TAGS="2_node_*_link_topo"
937             ;;
938         "3n_skx")
939             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
940             TOPOLOGIES_TAGS="3_node_*_link_topo"
941             ;;
942         "2n_dnv")
943             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
944             TOPOLOGIES_TAGS="2_node_single_link_topo"
945             ;;
946         "3n_dnv")
947             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
948             TOPOLOGIES_TAGS="3_node_single_link_topo"
949             ;;
950         "3n_hsw")
951             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
952             TOPOLOGIES_TAGS="3_node_single_link_topo"
953             ;;
954         "3n_tsh")
955             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
956             TOPOLOGIES_TAGS="3_node_single_link_topo"
957             ;;
958         *)
959             # No falling back to 3n_hsw default, that should have been done
960             # by the function which has set NODENESS and FLAVOR.
961             die "Unknown specification: ${case_text}"
962     esac
963
964     if [[ -z "${TOPOLOGIES-}" ]]; then
965         die "No applicable topology found!"
966     fi
967 }
968
969
970 function select_vpp_device_tags () {
971
972     # Variables read:
973     # - TEST_CODE - String affecting test selection, usually jenkins job name.
974     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
975     #   Can be unset.
976     # Variables set:
977     # - TAGS - Array of processed tag boolean expressions.
978
979     set -exuo pipefail
980
981     case "${TEST_CODE}" in
982         # Select specific device tests based on jenkins job type variable.
983         * )
984             if [[ -z "${TEST_TAG_STRING-}" ]]; then
985                 # If nothing is specified, we will run pre-selected tests by
986                 # following tags. Items of array will be concatenated by OR
987                 # in Robot Framework.
988                 test_tag_array=()
989             else
990                 # If trigger contains tags, split them into array.
991                 test_tag_array=(${TEST_TAG_STRING//:/ })
992             fi
993             ;;
994     esac
995
996     # Blacklisting certain tags per topology.
997     #
998     # Reasons for blacklisting:
999     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1000     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1001     case "${TEST_CODE}" in
1002         *"1n-vbox"*)
1003             test_tag_array+=("!avf")
1004             test_tag_array+=("!vhost")
1005             ;;
1006         *)
1007             ;;
1008     esac
1009
1010     TAGS=()
1011
1012     # We will prefix with devicetest to prevent running other tests
1013     # (e.g. Functional).
1014     prefix="devicetestAND"
1015     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1016         # Automatic prefixing for VPP jobs to limit testing.
1017         prefix="${prefix}"
1018     fi
1019     for tag in "${test_tag_array[@]}"; do
1020         if [[ ${tag} == "!"* ]]; then
1021             # Exclude tags are not prefixed.
1022             TAGS+=("${tag}")
1023         else
1024             TAGS+=("${prefix}${tag}")
1025         fi
1026     done
1027 }
1028
1029 function untrap_and_unreserve_testbed () {
1030
1031     # Use this as a trap function to ensure testbed does not remain reserved.
1032     # Perhaps call directly before script exit, to free testbed for other jobs.
1033     # This function is smart enough to avoid multiple unreservations (so safe).
1034     # Topo cleanup is executed (call it best practice), ignoring failures.
1035     #
1036     # Hardcoded values:
1037     # - default message to die with if testbed might remain reserved.
1038     # Arguments:
1039     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1040     # Variables read (by inner function):
1041     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1042     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1043     # Variables written:
1044     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1045     # Trap unregistered:
1046     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1047     # Functions called:
1048     # - die - Print to stderr and exit.
1049
1050     set -xo pipefail
1051     set +eu  # We do not want to exit early in a "teardown" function.
1052     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1053     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1054     if [[ -z "${wt-}" ]]; then
1055         set -eu
1056         warn "Testbed looks unreserved already. Trap removal failed before?"
1057     else
1058         cleanup_topo || true
1059         python "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1060             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1061         }
1062         WORKING_TOPOLOGY=""
1063         set -eu
1064     fi
1065 }
1066
1067
1068 function warn () {
1069
1070     # Print the message to standard error.
1071     #
1072     # Arguments:
1073     # - ${@} - The text of the message.
1074
1075     set -exuo pipefail
1076
1077     echo "$@" >&2
1078 }